/*************************************************************************************************
*
*
*			ObjectMacZapp		-- a standard Mac OOP application template
*
*
*
*			ZApplication.h			-- the application object
*
*
*
*
*
*			 1996, Graham Cox
*
*
*
*
*************************************************************************************************/


#pragma once

#ifndef __ZAPPLICATION__
#define	__ZAPPLICATION__

#include	"ZCommander.h"



class	ZEventHandler;
class	ZWindow;


class	ZApplication : public ZCommander
{
public:

	Boolean			done;				// normally FALSE, if TRUE, will quit
	short			phase;				// current phase
	ZEventHandler*	zEH;				// event handler object
	ZWindow*		mostRecent;			// most recently created window
	Handle			shortageFund;		// to deal with tight memory, we can release this
	Boolean			memIsShort;			// flag memory problem
	Boolean			userHasSeenAlert;	// TRUE if user has been warned about the memory
	
	
	ZApplication();
	~ZApplication();
	
	void				InitMacApplication();
	
	virtual void		InitMacZapp();
	virtual void		Run();
	virtual Boolean		Quit();
	virtual void		RequestQuit();
	virtual void		HandleCommand(short menuID, short itemID);
	virtual void		UpdateMenus();
	virtual void		MakeEventHandler();
	virtual void		MakeNewWindow();
	virtual void		OpenNewWindow();
	virtual Boolean		CheckCanRun();
	virtual void		InitMenuBar();
	virtual void		CloseAll();
	virtual ZWindow*	GetFrontWindow();
	virtual Boolean		PickFile(FSSpec* aFile, OSType* fType);
	virtual void		OpenFile(FSSpec* aFile, OSType fType);
	virtual Boolean		MemoryShortage(Size bytesShort);
	
	inline	short		GetPhase(){ return phase;};
};

// values of "phase"

enum
{
	kInitialising,
	kRunning,
	kQuitting
};



#define		kCantRunAlertID		131

extern	ZApplication*	gApplication;


#endif