/*************************************************************************************************
*
*
*			ObjectMacZapp		-- a standard Mac OOP application template
*
*
*
*			ZDefines.h			-- some handy constants, etc
*
*
*
*
*
*			 1996, Graham Cox
*
*
*
*
*************************************************************************************************/

#pragma once

#ifndef __ZDEFINES__
#define __ZDEFINES__

#define		kSleepTime			10		// number of ticks to give up to background programs
#define		kUntitledWindowID	128		// resource ID of the main window template
#define		kMenuBarID			128		// resource ID of the MBAR resource
#define		kAppleMenuID		128		// ID of the apple menu



#define		kFileMenu			129
#define		kEditMenu			130
#define		kShowAboutBox		1
#define		kAboutBoxID			128

#define		kStdMenubarID		128
#define		kMiscStrListID		128
#define		kExceptionAlertID	130
#define		kMemoryLowAlertID	132

#define		kShortageFundSize	20480	// leave 20K in reserve for emergencies.

enum
{
	kItemNew = 1,
	kItemOpen,
	kItemClose,
	kItemSave = 5,
	kItemSaveAs,
	kItemRevert,
	kItemPageSetup = 9,
	kItemPrint,
	kItemQuit = 12,
};


enum
{
	kUndoCmd = 1,
	kCutCmd = 3,
	kCopyCmd,
	kPasteCmd,
	kClearCmd
};


#define		kConfirmSaveAlertID	129

enum
{
	kConfirmSave = 1,
	kCloseNoSave,
	kCloseCancel
};

#define		IS_ZWINDOW_KIND		772	// in the 'kind' field of the window record




#define		GetZWindow(w)		(((WindowPeek) w)->windowKind == IS_ZWINDOW_KIND)? \
									(ZWindow*) GetWRefCon(w) : NULL
									
#define		ForgetObject(p)		delete (p); (p) = NULL

#define		ForgetThis()		delete this


#define		kUnknownExceptionErr	-999


extern OSType		gMacZoopSignature;		
extern Boolean		gIsAColourMac;	


#endif