/*************************************************************************************************
*
*
*			ObjectMacZapp		-- a standard Mac OOP application template
*
*
*
*			ZEventHandler.h		-- the event handler object
*
*
*
*
*
*			 1996, Graham Cox
*
*
*
*
*************************************************************************************************/

#pragma once

#ifndef __ZEVENTHANDLER__
#define __ZEVENTHANDLER__


class	ZWindow;
class	ZCommander;


class	ZEventHandler
{
public:
	short			clicks;				// number of mouse-clicks in a series
	EventRecord		theEvent;			// the event recovered from queue
	Boolean			inBackground;		// TRUE if app in background

	ZEventHandler();
	
	virtual void	GetAnEvent();
	virtual void	DispatchAnEvent();
	virtual void	CountClicks(WindowPtr target, long clickTicks);
	virtual void	HandleMouseEvent(EventRecord* theEvent);
	virtual void	HandleWindowUpdate(WindowPtr theWindow);
	virtual void	HandleMenuSelection(long mSelect);
	virtual void	PassIdle();
	virtual void	DisableMenus();
	virtual void	HandleWindowActivate(WindowPtr theWindow, Boolean state);
	virtual void	HandleHLEvent(EventRecord* theEvent);
	virtual void	HandleOSEvent(EventRecord* theEvent);
	virtual void	InstallApplescriptHandlers();
	
	inline short	GetClicks(){ return clicks;};
	inline Boolean	InBackground(){ return inBackground;};
};



extern		short			gSleep;
extern		ZCommander*		gCurHandler;


#define		kFrontSleep		10
#define		kBackSleep		50


#endif