/*************************************************************************************************
*
*
*			ObjectMacZapp		-- a standard Mac OOP application template
*
*
*
*			ZWindow.h		-- the window object
*
*
*
*
*
*			 1996, Graham Cox
*
*
*
*
*************************************************************************************************/

#pragma once

#ifndef __ZWINDOW__
#define	__ZWINDOW__

#include	"ZCommander.h"

class	ZWindow : public ZCommander
{
public:

	Rect		sizeRect;			// min and max sizes for window
	WindowPtr	macWindow;			// the mac window associated with this object
	short		windID;				// res ID of 'WIND' template
	Boolean		dirty;				// TRUE if window needs to be saved
	Boolean		isNamed;			// TRUE if window has a name other than "untitled"
	FSSpec		macFile;			// the file that corresponds to this window
	
	ZWindow(ZCommander* aBoss, short windowID);
	virtual ~ZWindow();
	
	virtual void	InitZWindow();
	virtual void	MakeMacWindow(short windID);
	virtual void	Activate();
	virtual void	Deactivate();
	virtual void	Focus();
	virtual void	Draw();
	virtual void	DrawGrow();
	virtual void	DrawContent();
	virtual void	Click(Point mouse, short modifiers);
	virtual void	Type(char theChar);
	virtual void	SetSizeRect(Rect* szRect);
	virtual void	GetSizeRect(Rect* szRect);
	virtual Boolean	Close(short phase);
	virtual void	Hide();
	virtual void	Show();
	virtual void	Select();
	virtual void	PlaceAt(short hGlobal, short vGlobal);
	virtual void	HandleCommand(short menuID, short itemID);
	virtual void	UpdateMenus();
	virtual void	SetSize(short width, short height);
	virtual void	Zoom(short partCode);
	virtual Boolean	Save(Boolean forceSaveAs = FALSE);
	virtual void	SaveFile();
	virtual void	GetName(Str255 name);
	virtual void	Revert();
	virtual void	SetFile(FSSpec* aFile);
	virtual void	OpenFile(OSType aFileType);
	virtual void	GetContentRect(Rect* contents);

	virtual ZCommander*	GetHandler();
	
	inline WindowPtr	GetMacWindow(){ return macWindow; };
};



#define			kNoFile		-9999


// ZWindows manage mac windows. The refCon of a macWindow in Object MacZapp is the object
// reference.


// methods are:

/*

MakeMacWindow- 	makes the window from a 'WIND' template and sets it up
Activate- 		this window was selected
Deactivate- 	this window was deactivated
Focus- 			makes this window the current port
Draw- 			draws the content region
Click- 			the mouse went down in the content region
SetSizeRect- 	sets the min and max sizes for growing the window
Close- 			closes this window (by default this disposes it)
Hide- 			hides the window
Show- 			shows the window
Select-			make the window active
Idle- 			periodically called when current
HandleCommand- 	handle a menu command.
UpdateMenus- 	enable menus that apply to this window
SetSize-		sets the window to the width and height passed, constrained to the size rect.
Zoom-			zoom the window from std to user and vice versa
Save-			save the data on disk, optionally naming the window/file
GetName-		returns the title of the window



*/



#endif