/*************************************************************************************************
*
*
*			ObjectMacZapp		-- a standard Mac OOP application template
*
*
*
*			ZCommander.cpp			-- an object for handling commands
*
*
*
*
*
*			 1996, Graham Cox
*
*
*
*
*************************************************************************************************/

#include	"ZCommander.h"


/*----------------------------------***  CONSTRUCTOR  ***----------------------------------*/

ZCommander::ZCommander(ZCommander* aBoss)
{
	itsBoss = aBoss;
}

/*-------------------------------***  HANDLECOMMAND  ***---------------------------------*/
/*	

if it has a boss, it passes the command to it for handling

----------------------------------------------------------------------------------------*/

void	ZCommander::HandleCommand(short menuID, short itemID)
{
	if (itsBoss)
		itsBoss->HandleCommand(menuID, itemID);
}


/*-------------------------------***  UPDATEMENUS  ***---------------------------------*/
/*	

if it has a boss, it asks it to update its menus

----------------------------------------------------------------------------------------*/

void	ZCommander::UpdateMenus()
{
	if (itsBoss)
		itsBoss->UpdateMenus();
}


/*-----------------------------------***  IDLE  ***-------------------------------------*/
/*	

called periodically if this is in the chain of command. It passes the call up to its boss.

----------------------------------------------------------------------------------------*/

void	ZCommander::Idle()
{
	if (itsBoss)
		itsBoss->Idle();
}